let elmCompilerSingleton = Promise.resolve();

async function aquireLock() {
  let release;
  const before = elmCompilerSingleton;
  elmCompilerSingleton = new Promise((resolve) => {
    release = resolve;
  });
  await before;
  return release;
}

async function wait(name) {
  console.log('aquiring lock for', name);
  const releaseLock = await aquireLock();
  console.log('aquired lock for', name);

  setTimeout(() => {
    console.log('Done with', name);
    releaseLock();
  }, 200);
}

wait(1);
wait(2);
wait(3);
wait(4);
